var FancyWebSocket = function(url)
{
	var callbacks = {};	
	var ws_url = url;
	var conn;
	
	var socketQueue = {};
	var socketQueueId = 0;

	this.bind = function(event_name, callback){
		callbacks[event_name] = callbacks[event_name] || [];
		callbacks[event_name].push(callback);
		return this;// chainable
	};

	this.send = function(event_name, event_data){
		this.conn.send( event_data );
		return this;
	};
	
	this.jsCalback = function(event_name, event_data, callbackFunc){
		socketQueueId++;
		var id_sent = socketQueueId;
		event_data = JSON.parse(event_data);
		event_data.data = event_data.data + '&req_id=' + id_sent;
		event_data = JSON.stringify(event_data);
		this.conn.send( event_data );
		this.conn.onmessage = function(evt){			
			var req_id = evt.data.substring(evt.data.indexOf("[req_id]")+8,evt.data.indexOf("[/req_id]"));
			if(id_sent == req_id){
				returnBlock = evt.data.substring(evt.data.indexOf("[JSResp]")+8,evt.data.indexOf("[/JSResp]"));
				callbackFunc(returnBlock, event_data);
			}else{dispatch('message', evt.data);}
		}
	}

	this.connect = function() {
		if ( typeof(MozWebSocket) == 'function' )
			this.conn = new MozWebSocket(url);
		else if( typeof(WebSocket) == 'function' )
			this.conn = new WebSocket(url);
		else return false;
		// dispatch to the right handlers
		this.conn.onmessage = function(evt){
			dispatch('message', evt.data);
		};
		this.conn.onclose = function(){dispatch('close',null)}
		this.conn.onopen = function(){dispatch('open',null)}
	};

	this.disconnect = function() {
		this.conn.close();
	};

	var dispatch = function(event_name, message){
		var chain = callbacks[event_name];
		if(typeof chain == 'undefined') return; // no callbacks for this event
		for(var i = 0; i < chain.length; i++){
			chain[i]( message )
		}
	}
};